
#import "CICCS64ColorCorrectionFilter.h"


@implementation CICCS64ColorCorrectionFilter


static CIKernel* sColorCorrectionKernal = nil;

static NSString* sColorCorrectionKernalCode = @"\
bool isNearColor(vec4 color1, vec4 color2)											\n\
{																					\n\
	vec4 diff = color1 - color2;													\n\
	float scalar_diff = dot(diff, diff);											\n\
																					\n\
	return scalar_diff < 0.02;														\n\
}																					\n\
																					\n\
kernel vec4 colorCorrection(sampler source_image)									\n\
{																					\n\
	vec4 correct_color_0 = vec4(0.000, 0.000, 0.000, 1.000);						\n\
	vec4 correct_color_1 = vec4(1.000, 1.000, 1.000, 1.000);						\n\
	vec4 correct_color_2 = vec4(0.408, 0.216, 0.169, 1.000);						\n\
	vec4 correct_color_3 = vec4(0.439, 0.643, 0.698, 1.000);						\n\
	vec4 correct_color_4 = vec4(0.435, 0.239, 0.525, 1.000);						\n\
	vec4 correct_color_5 = vec4(0.345, 0.553, 0.263, 1.000);						\n\
	vec4 correct_color_6 = vec4(0.208, 0.157, 0.475, 1.000);						\n\
	vec4 correct_color_7 = vec4(0.722, 0.780, 0.435, 1.000);						\n\
	vec4 correct_color_8 = vec4(0.435, 0.310, 0.145, 1.000);						\n\
	vec4 correct_color_9 = vec4(0.263, 0.224, 0.000, 1.000);						\n\
	vec4 correct_color_a = vec4(0.604, 0.404, 0.349, 1.000);						\n\
	vec4 correct_color_b = vec4(0.267, 0.267, 0.267, 1.000);						\n\
	vec4 correct_color_c = vec4(0.424, 0.424, 0.424, 1.000);						\n\
	vec4 correct_color_d = vec4(0.604, 0.824, 0.518, 1.000);						\n\
	vec4 correct_color_e = vec4(0.424, 0.369, 0.710, 1.000);						\n\
	vec4 correct_color_f = vec4(0.584, 0.584, 0.584, 1.000);						\n\
																					\n\
	vec4 false_color_0 = vec4(0.000, 0.000, 0.000, 1.000);							\n\
	vec4 false_color_1 = vec4(1.000, 1.000, 1.000, 1.000);							\n\
	vec4 false_color_2 = vec4(0.878, 0.251, 0.251, 1.000);							\n\
	vec4 false_color_3 = vec4(0.376, 1.000, 1.000, 1.000);							\n\
	vec4 false_color_4 = vec4(0.878, 0.376, 0.878, 1.000);							\n\
	vec4 false_color_5 = vec4(0.251, 0.878, 0.251, 1.000);							\n\
	vec4 false_color_6 = vec4(0.251, 0.251, 0.878, 1.000);							\n\
	vec4 false_color_7 = vec4(1.000, 1.000, 0.251, 1.000);							\n\
	vec4 false_color_8 = vec4(0.878, 0.627, 0.251, 1.000);							\n\
	vec4 false_color_9 = vec4(0.612, 0.455, 0.282, 1.000);							\n\
	vec4 false_color_a = vec4(1.000, 0.627, 0.627, 1.000);							\n\
	vec4 false_color_b = vec4(0.329, 0.329, 0.329, 1.000);							\n\
	vec4 false_color_c = vec4(0.533, 0.533, 0.533, 1.000);							\n\
	vec4 false_color_d = vec4(0.627, 1.000, 0.627, 1.000);							\n\
	vec4 false_color_e = vec4(0.627, 0.627, 1.000, 1.000);							\n\
	vec4 false_color_f = vec4(0.753, 0.753, 0.753, 1.000);							\n\
																					\n\
	vec4 pixel = sample(source_image, samplerCoord(source_image));					\n\
	vec4 new_pixel = pixel;															\n\
	new_pixel = isNearColor(pixel, false_color_0) ? correct_color_0 : new_pixel;	\n\
	new_pixel = isNearColor(pixel, false_color_1) ? correct_color_1 : new_pixel;	\n\
	new_pixel = isNearColor(pixel, false_color_2) ? correct_color_2 : new_pixel;	\n\
	new_pixel = isNearColor(pixel, false_color_3) ? correct_color_3 : new_pixel;	\n\
	new_pixel = isNearColor(pixel, false_color_4) ? correct_color_4 : new_pixel;	\n\
	new_pixel = isNearColor(pixel, false_color_5) ? correct_color_5 : new_pixel;	\n\
	new_pixel = isNearColor(pixel, false_color_6) ? correct_color_6 : new_pixel;	\n\
	new_pixel = isNearColor(pixel, false_color_7) ? correct_color_7 : new_pixel;	\n\
	new_pixel = isNearColor(pixel, false_color_8) ? correct_color_8 : new_pixel;	\n\
	new_pixel = isNearColor(pixel, false_color_9) ? correct_color_9 : new_pixel;	\n\
	new_pixel = isNearColor(pixel, false_color_a) ? correct_color_a : new_pixel;	\n\
	new_pixel = isNearColor(pixel, false_color_b) ? correct_color_b : new_pixel;	\n\
	new_pixel = isNearColor(pixel, false_color_c) ? correct_color_c : new_pixel;	\n\
	new_pixel = isNearColor(pixel, false_color_d) ? correct_color_d : new_pixel;	\n\
	new_pixel = isNearColor(pixel, false_color_e) ? correct_color_e : new_pixel;	\n\
	new_pixel = isNearColor(pixel, false_color_f) ? correct_color_f : new_pixel;	\n\
																					\n\
	return new_pixel;																\n\
}";

 
// ----------------------------------------------------------------------------
+ (void) initialize
// ----------------------------------------------------------------------------
{
	NSArray* categories = [NSArray arrayWithObjects:kCICategoryColorAdjustment, kCICategoryVideo, kCICategoryStillImage, kCICategoryInterlaced, kCICategoryNonSquarePixels, nil];
	[CIFilter registerFilterName:@"CICCS64ColorCorrection" constructor: self classAttributes:[NSDictionary dictionaryWithObjectsAndKeys:@"CCS64 Color Correction", kCIAttributeFilterDisplayName, 
																																		categories, kCIAttributeFilterCategories, nil]];
}


// ----------------------------------------------------------------------------
+ (CIFilter*) filterWithName:(NSString*)name
// ----------------------------------------------------------------------------
{
    return [[self alloc] init];
}


// ----------------------------------------------------------------------------
- (id) init
// ----------------------------------------------------------------------------
{
    if (sColorCorrectionKernal == nil)
    {
        NSArray* kernels = [CIKernel kernelsWithString:sColorCorrectionKernalCode];
        sColorCorrectionKernal = [kernels objectAtIndex:0];
    }
	
    return [super init];
}


// ----------------------------------------------------------------------------
- (CIImage*) outputImage
// ----------------------------------------------------------------------------
{
    CISampler* inputSampler = [CISampler samplerWithImage:inputImage];

	/*
	static NSImage* peptoImage = [NSImage imageNamed:@"pepto_palette"];
	static NSImage* ccs64Image = [NSImage imageNamed:@"ccs64_palette"];
	
	CGColorSpaceRef colorSpace = CGColorSpaceCreateWithName(kCGColorSpaceGenericRGBLinear);
	CIImage* ciPeptoImage = [CIImage imageWithData:[peptoImage TIFFRepresentation] options:[NSDictionary dictionaryWithObjectsAndKeys:(id)colorSpace, kCIImageColorSpace, nil]];
	CIImage* ciCcs64Image = [CIImage imageWithData:[ccs64Image TIFFRepresentation] options:[NSDictionary dictionaryWithObjectsAndKeys:(id)colorSpace, kCIImageColorSpace, nil]];
	CGColorSpaceRelease(colorSpace);
	
	CISampler* peptoSampler = [CISampler samplerWithImage:ciPeptoImage];
	CISampler* ccs64Sampler = [CISampler samplerWithImage:ciCcs64Image];

	CIImage* outputImage = [self apply:sColorCorrectionKernal, inputSampler, peptoSampler, ccs64Sampler, kCIApplyOptionDefinition, [inputSampler definition], nil];
	*/
	
	CIImage* outputImage = [self apply:sColorCorrectionKernal, inputSampler, kCIApplyOptionDefinition, [inputSampler definition], nil];
	
    return outputImage;
}

@end
