
#import "GBBrowserWindow.h"


@implementation GBBrowserWindow


// ----------------------------------------------------------------------------
- (void) awakeFromNib
// ----------------------------------------------------------------------------
{
    NSString* key = [NSString stringWithFormat:@"NSSplitView Subview Frames %@", splitView.autosaveName];
    NSArray* subviewFrames = [[NSUserDefaults standardUserDefaults] valueForKey:key];
    
    if (subviewFrames.count == 0)
        return;
    
    // the last frame is skipped because I have one less divider than I have frames
    for (NSInteger i=0; i < (subviewFrames.count - 1); i++ )
    {
        // this is the saved frame data - it's an NSString
        NSString* frameString = subviewFrames[i];
        NSArray* components = [frameString componentsSeparatedByString:@", "];
        
        // only one component from the string is needed to set the position
        CGFloat position;
        
        if (splitView.vertical)
            position = [components[2] floatValue];
        else
            position = [components[3] floatValue];
        
        [splitView setPosition:position ofDividerAtIndex:i];
    }
}


// ----------------------------------------------------------------------------
- (NSTableView*) tableView
// ----------------------------------------------------------------------------
{
	return tableView;
}


@end
