
#import <Cocoa/Cocoa.h>

@class GBSourceListItem;


@interface GBDatabaseFileDownloadController : NSObject
{
	IBOutlet NSProgressIndicator* downloadProgressIndicator;
	IBOutlet NSTextField* downloadProgressLabel;
	IBOutlet NSTextField* downloadVersionSelectLabel;
	IBOutlet NSTextField* downloadVersionDetectedLabel;
	IBOutlet NSPopUpButton* downloadVersionPopUpButton;
	IBOutlet NSButton* downloadButton;
	
	NSURLConnection* databaseListURLConnection;
	NSMutableData* databaseListData;

	NSURLConnection* databaseFileURLConnection;
	NSMutableData* databaseFileData;
	NSString* databaseFileName;
	
	NSInteger downloadFileSize;
	
	NSMutableArray* databaseFileURLs;
	GBSourceListItem* downloadDatabaseItem;
	NSString* _databaseFolderName;
}

@property (nonatomic) NSString* databaseFolderName;

- (void) prepareDownloadForDatabase:(GBSourceListItem*)databaseItem;
- (IBAction) downloadButtonClicked:(id) sender;

@end



@interface NSData (NSDataExtension)

- (NSData*) gzipInflate;

@end