
#import <Cocoa/Cocoa.h>
#import <Quartz/Quartz.h>



@interface GBExtrasBrowserItem : NSObject <QLPreviewItem>
{
	NSString* _path;
	NSString* _title;
	NSString* _subTitle;
}

@property (nonatomic) NSString* path;
@property (nonatomic) NSString* title;
@property (nonatomic) NSString* subTitle;

- (id) initWithPath:(NSString*)thePath andTitle:(NSString*)theTitle andSubTitle:(NSString*)theSubTitle;

- (NSURL*) previewItemURL;
- (NSString*) previewItemTitle;

@end



@interface GBExtrasBrowserView : IKImageBrowserView
{
	IBOutlet NSMenu* contextMenu;

	QLPreviewPanel* _previewPanel;
}

@property (nonatomic) QLPreviewPanel* previewPanel;

- (BOOL) acceptsPreviewPanelControl:(QLPreviewPanel*)panel;
- (void) beginPreviewPanelControl:(QLPreviewPanel*)panel;
- (void) endPreviewPanelControl:(QLPreviewPanel*)panel;


@end



@interface GBExtrasBrowserDataSource : NSObject <QLPreviewPanelDataSource, QLPreviewPanelDelegate>
{
	NSMutableArray* _browserData;
	IBOutlet GBExtrasBrowserView* _browserView;
}

@property (nonatomic) NSMutableArray* browserData;
@property (nonatomic) GBExtrasBrowserView* browserView;


- (IBAction) revealExtraItemInFinder:(id)sender;
- (IBAction) copyPathOfExtraItemToClipboard:(id)sender;


@end


