
#import <Cocoa/Cocoa.h>
#import <Quartz/Quartz.h>
#import <QuartzCore/QuartzCore.h>

@class GBExtrasBrowserDataSource;
@class GBGameTableDataSource;
@class GBDatabaseFileDownloadController;


@interface GBGameDetailController : NSObject
{
	NSString* _gameName;
	NSString* _gameInfo;
	NSImage* _gameScreenshot;
	NSString* _gameDetailLeftColumn;
	
	NSMutableDictionary* currentGameTableRow;
	BOOL isShowingVersionInfo;
	
	NSString* _currentItemMusicPath;
	NSString* _currentItemGamePath;
	NSString* _currentItemGameToRun;
	NSNumber* _currentItemGameId;
	
	BOOL _hasSingleValidSelection;
	
	NSInteger sequelGameId;
	NSInteger prequelGameId;
	NSInteger relatedGameId;
	
	NSMutableArray* screenShotPaths;
	NSInteger _screenShotIndex;
	
	BOOL isShowingDatabaseDownloadView;
	
	IBOutlet NSSegmentedControl* screenShotControl;
	IBOutlet NSTextField* screenShotLabel;
	IBOutlet NSImageView* screenShotView;
	IBOutlet NSButton* palEffectButton;
	IBOutlet NSButton* colorCorrectionButton;
	IBOutlet NSTextField* gameNameLabel;

	IBOutlet NSView* gameDetailView;
	IBOutlet NSView* extrasView;
	IBOutlet NSView* backgroundView;
	IBOutlet NSView* databaseDownloadView;
	
	IBOutlet NSButton* gameInfoButton;
	IBOutlet NSButton* versionInfoButton;
	IBOutlet NSButton* extrasButton;
	IBOutlet NSButton* prequelButton;
	IBOutlet NSButton* sequelButton;
	IBOutlet NSButton* relatedButton;
	IBOutlet NSButton* webPageButton;
	
	IBOutlet GBExtrasBrowserDataSource* extrasDataSource;
	IBOutlet GBGameTableDataSource* gameTableDataSource;
	
	IBOutlet GBDatabaseFileDownloadController* databaseDownloadController;
	
	IBOutlet IKImageBrowserView* imageBrowserView;
}


@property (nonatomic, strong) NSString* gameName;
@property (nonatomic, strong) NSString* gameInfo;
@property (nonatomic, strong) NSImage* gameScreenshot;
@property (nonatomic, strong) NSString* gameDetailLeftColumn;
@property (nonatomic, strong) NSNumber* currentItemGameId;
@property (nonatomic, strong) NSString* currentItemMusicPath;
@property (nonatomic, strong) NSString* currentItemGamePath;
@property (nonatomic, strong) NSString* currentItemGameToRun;
@property (nonatomic, assign) NSInteger screenShotIndex;
@property (nonatomic, assign) BOOL hasSingleValidSelection;

- (void) showMultipleSelection;
- (void) showEmptySelection;
- (void) hideAllFields;

- (void) reloadGameDetails:(NSMutableDictionary*)selectedGame andUpdateExtrasBrowser:(BOOL)updateExtras;

- (void) setScreenShotWithIndex:(NSInteger)index;
- (IBAction) previousScreenshot:(id)sender;
- (IBAction) nextScreenshot:(id)sender;
- (IBAction) changeScreenshot:(id)sender;

- (void) enablePalEffect:(BOOL)enablePalEffect andEnableColorCorrection:(BOOL)enableColorCorrection;
- (IBAction) togglePalEffect:(id)sender;
- (IBAction) toggleColorCorrection:(id)sender;

- (IBAction) gameDetailsTypeChanged:(id)sender;
- (IBAction) toggleExtras:(id)sender;

- (IBAction) switchToGameInfoView:(id)sender;
- (IBAction) switchToVersionInfoView:(id)sender;
- (IBAction) switchToExtrasView:(id)sender;

- (void) triggerFlipTransition;
- (CAAnimation*) flipAnimationWithDuration:(CGFloat)duration isFront:(BOOL)isFront;

- (IBAction) findLongPlayVideo:(id)sender;

- (IBAction) showSequel:(id)sender;
- (IBAction) showPrequel:(id)sender;
- (IBAction) showRelated:(id)sender;
- (IBAction) showWebPage:(id)sender;

- (void) showDatabaseDownloadView;
- (void) hideDatabaseDownloadView;


@end
