
#import <Cocoa/Cocoa.h>
#import <Quartz/Quartz.h>

@class GBGameTableDataSource;


@interface GBImageBrowserItem : NSObject
{
	NSString* _path;
	NSString* _title;
	NSString* _subTitle;
}

@property (nonatomic) NSString* path;
@property (nonatomic) NSString* title;
@property (nonatomic) NSString* subTitle;

- (id) initWithPath:(NSString*)thePath andTitle:(NSString*)theTitle andSubTitle:(NSString*)theSubTitle;

@end


@interface GBImageBrowserView : IKImageBrowserView
{
	IBOutlet NSMenu* contextMenu;
}

@end


@interface GBImageBrowserCell : IKImageBrowserCell
{

}

@end


@interface GBImageBrowserDataSource : NSObject
{
	NSMutableArray* _browserData;
	NSMutableArray* _unfilteredBrowserData;
	NSMutableArray* _unfilteredSearchBrowserData;
	IBOutlet GBImageBrowserView* _browserView;
	IBOutlet NSTableView* _tableBrowserView;
	IBOutlet GBGameTableDataSource* _tableDataSource;
}

@property (nonatomic) NSMutableArray* browserData;
@property (nonatomic) NSMutableArray* unfilteredBrowserData;
@property (strong, retain) NSMutableArray* unfilteredSearchBrowserData;
@property (nonatomic) GBImageBrowserView* browserView;
@property (nonatomic) GBGameTableDataSource* tableDataSource;

- (void) reloadData;
- (IBAction) zoomSliderDidChange:(id)sender;

@end