#import <Cocoa/Cocoa.h>

@class GBSourceListDataSource;

enum GBSearchType
{
	SEARCH_ALL = 0,
	SEARCH_NAME,
	SEARCH_YEAR,
	SEARCH_GENRE,
	SEARCH_PUBLISHER
};


enum GBEmulatorType
{
	EMULATOR_UNKNOWN = 0,
	EMULATOR_VICE_X64,
	EMULATOR_VICE_X64SC,
	EMULATOR_POWER64,
    EMULATOR_MICRO64
};


struct Preferences
{
	void				initializeDefaults();
	
	NSMutableArray*		mDatabases;
	GBSearchType		mSearchType;
	NSString*			mEmulatorToolPath;
	NSString*			mSidPlayerToolPath;
	GBEmulatorType		mEmulatorType;
	NSInteger			mLastViewedGameId;
	BOOL				mImageGridMode;
	BOOL				mLaunchSidPlayerInBackground;
	BOOL				mPalEffectEnabled;
	BOOL				mColorCorrectionEnabled;
};

extern Preferences		gPreferences;


@interface GBPreferencesController : NSObject
{
	BOOL loaded;
}

+ (void) initialize;
+ (GBPreferencesController*) sharedInstance;

- (void) load;
- (void) save;

@end
