#import <Cocoa/Cocoa.h>

#import "GBPreferencesController.h"


@interface ToolDropBox : NSImageView
{
	IBOutlet id owner;
}

@end


@interface GBTool : NSObject
{
	NSString* _name;
	NSString* _path;
	BOOL latestOneUsed;
}

@property (nonatomic) NSString* name;
@property (nonatomic) NSString* path;
@property (assign) BOOL latestOneUsed;

- (id) initWithName:(NSString*)theName andPath:(NSString*)thePath;

@end


@interface GBEmulatorTool : GBTool
{
	GBEmulatorType type; 
}

@property (assign) GBEmulatorType type;

- (id) initWithName:(NSString*)theName andPath:(NSString*)thePath andType:(GBEmulatorType)theType;

@end


@interface GBSidPlayerTool : GBTool
{
	
}

@end


@interface GBPreferencesWindowController : NSWindowController <NSMetadataQueryDelegate>
{
	NSMutableArray* _emulatorTools;
	NSMutableArray* _sidPlayerTools;

	NSMetadataQuery* emulatorSearchQuery;
	NSMetadataQuery* sidPlayerSearchQuery;
	
	IBOutlet ToolDropBox* emulatorDropBox;
	IBOutlet ToolDropBox* sidPlayerDropBox;
	
	IBOutlet NSPopUpButton* emulatorPopUpButton;
	IBOutlet NSPopUpButton* sidPlayerPopUpButton;

	IBOutlet NSButton* launchSidPlayerInBackgroundButton;
}

@property (nonatomic) NSMutableArray* emulatorTools;
@property (nonatomic) NSMutableArray* sidPlayerTools;

- (IBAction) emulatorToolChanged:(id)sender;
- (IBAction) sidPlayerToolChanged:(id)sender;
- (IBAction) sidPlayerLaunchBehaviourChanged:(id)sender;

- (void) toolDroppedOn:(id)sender withPath:(NSString*)path;

- (void) findTools;
- (void) updateToolsIcons;

- (GBEmulatorType) getEmulatorTypeFromBundleIdentifier:(NSString*)bundleIdentifier;

@end
