
#import <Foundation/Foundation.h>
#import <sqlite3.h>


@interface SQLite3Connector : NSObject
{
	sqlite3* database;
}

+ (NSString*) escapeString:(NSString*)string;
+ (BOOL) dropDatabase:(NSString*)dataBasePath;
+ (BOOL) databaseExists:(NSString*)dataBasePath;
+ (NSArray *) getDatabaseFilePaths:(NSString*)path;
+ (int) getDatabaseFileSize:(NSString*)path;
+ (NSString*) getDatabaseFormatedFileSize:(NSString*)dataBasePath;

- (NSMutableArray *) getData:(NSString*)query fromDatabase:(NSString*)dataBasePath;
- (BOOL) executeQuery:(NSString*)query inDatabase:(NSString*)dataBasePath;
- (int) executeScalar:(NSString*)query inDatabase:(NSString*)dataBasePath;
- (BOOL) tableExists:(NSString*)tableName inDatabase:(NSString*)dataBasePath;
- (BOOL) truncateTable:(NSString*)tableName inDatabase:(NSString*)dataBasePath;
- (BOOL) truncateTable:(NSString*)tableName inDatabase:(NSString*)dataBasePath useVacuum:(BOOL)use;
- (BOOL) dropTable:(NSString*)tableName inDatabase:(NSString*)dataBasePath;
- (BOOL) dropTable:(NSString*)tableName inDatabase:(NSString*)dataBasePath useVacuum:(BOOL)use;
- (NSMutableArray *) getTablesInDatabase:(NSString*)dataBasePath;

@end
